From: Ben Hutchings <ben.hutchings@codethink.co.uk>
Date: Fri, 26 Jun 2020 20:14:56 +0100
Subject: hgweb: Fix fqaddr manipulation on Python 3

In Python 3.7 and 3.8 (I didn't test 3.6), socket.getfqdn() may return
a str or its argument (which can be bytes).  Currently hgweb assumes
it always returns a str, which leads to a number of test failures.
Convert the return value with sysbytes and then assume it is a byte
string.

--- a/mercurial/hgweb/__init__.py
+++ b/mercurial/hgweb/__init__.py
@@ -88,11 +88,11 @@
             bindaddr = '[%s]' % bindaddr
 
         fqaddr = self.httpd.fqaddr
-        if ':' in fqaddr:
-            fqaddr = '[%s]' % fqaddr
+        if b':' in fqaddr:
+            fqaddr = b'[%s]' % fqaddr
 
         url = b'http://%s%s/%s' % (
-            pycompat.sysbytes(fqaddr),
+            fqaddr,
             pycompat.sysbytes(port),
             prefix,
         )
--- a/mercurial/hgweb/server.py
+++ b/mercurial/hgweb/server.py
@@ -382,7 +382,7 @@
         self.errorlog = elog
 
         self.addr, self.port = self.socket.getsockname()[0:2]
-        self.fqaddr = socket.getfqdn(addr[0])
+        self.fqaddr = pycompat.sysbytes(socket.getfqdn(addr[0]))
 
         self.serverheader = ui.config(b'web', b'server-header')
 
